package com.zcxk.process.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zcxk.process.dto.ProcessDefinitionDTO;
import com.zcxk.process.entity.ProcessDefinition;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * (ProcessDefinition)表数据库访问层
 *
 * @author hym
 * @since 2020-12-22 16:55:18
 */
@Mapper
public interface ProcessDefinitionMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ProcessDefinition selectById(Integer id);


    /**
     * 查询全部
     *
     * @return 对象列表
     */
    List<ProcessDefinition> selectAll();

    /**
     * 通过实体作为筛选条件查询
     *
     * @param processDefinition 实例对象
     * @return 对象列表
     */
    List<ProcessDefinition> selectList(ProcessDefinition processDefinition);

    /**
     * 新增数据
     *
     * @param processDefinition 实例对象
     * @return 影响行数
     */
    int insert(ProcessDefinition processDefinition);

    /**
     * 批量新增
     *
     * @param processDefinitions 实例对象的集合
     * @return 影响行数
     */
    int batchInsert(@Param("processDefinitions") List<ProcessDefinition> processDefinitions);

    /**
     * 修改数据
     *
     * @param processDefinition 实例对象
     * @return 影响行数
     */
    int update(ProcessDefinition processDefinition);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    int count();

    IPage<ProcessDefinitionDTO> selectPage(IPage<ProcessDefinitionDTO> page, ProcessDefinition processDefinition);

    int checkProcessUnique(Object o, String tenantId, Integer companyOrgId, Integer taskType);

    String getBpmnContent(Integer processId);

    void insertSelective(ProcessDefinition processDefinition);
}